# TimeTable Zope product
# Utils
#
# Peter Bengtsson <mail@peterbe.com>
# Start date: 03/10 -01
#

try:
    from DateTime.DateTime import DateTime
except ImportError:
    print "DateTime could not be imported"

import string


def findEventId(self):
    """ return an appropriate id that is not taken """
    ids = self.objectIds('TimeTable Event')
    ids_n = []
    for id in ids:
        try:
            ids_n.append(int(id))
        except:pass
    if len(ids_n) > 0:
        newid = max(ids_n)+1
    else:
        newid = 1
    return string.zfill(newid,2)


def manylists2one(listlists):
    """ make [['a','b'],['z']]
        into ['a','b','z']
    """
    nl=[]
    for each in listlists:
        if type(each)!=type([]):
            nl.append(each)
        else:
            for e in each:
                nl.append(e)
    return nl

def timeAsDateObject(t):
    """
        glue the time to any specific date
        and convert to a time object
    """
    return DateTime('1979/12/13 %s'%t)


def todaysDay():
    """
        return "monday" if today is a monday.
        Do not return it in local form
    """
    
    now = DateTime()
    return now.strftime('%A').lower()

def nowsTime():
    """
        return the hour now as the format
        we expect.
    """
    now = DateTime()
    time = "%s:%s"%(now.hour(), now.minute())

    return time


def cookTime(t):
    """
        prepare the value of t to help user pass the
        requirements of what the value should be
    """
    t = str(t).lower().strip()
    if t.count(':')==0:
        # hmm, perhaps like this: 0950 or 950
        if len(t)==4:
            t = "%s:%s"%(t[0:2],t[2:4])
        elif len(t)==3:
            t = "0%s:%s"%(t[0:1],t[1:3])
    return t

def cookDay(d):
    """ prepare the value of d to help user
    pass the requirements of what the value should
    be
    """
    d = str(d)
    d = d.strip().lower()
    abbrs ={'mon':'monday','tue':'tuesday','wed':'wednesday',
            'thu':'thursday','fri':'friday',
            'sat':'saturday','sun':'sunday'}
    if abbrs.has_key(d):
        d = abbrs[d]

    return d


def validTime(t):
    """ expect time to be   '00:00' or
                            '23:59' or
                            '5:00'

        '5:1' will not be accepted!
    """
    try:
        h,m = t.split(':')
        h=int(h)
        if not (h >=0 and h <24):
            return 0
        if not len(str(m))==2:
            return 0
        if not (int(m) >=0 and int(m) <60):
            return 0

        # still here then
        return 1
    except SyntaxError:
        raise
    except:
        return 0
    

if __name__=='__main__':
    hr = "= = = = = = = = = = = = = = ="
    print "\n\nTEST THINGS"
    print cookTime(950), "9:50"
    print cookTime(' 10:11 '), "10:11"

    print hr
    print cookDay('Tuesday '), "tuesday"
    print cookDay(' Wed'), "wednesday"

    
